__doc__='''EmployX product module
$Id: EmployXCustomizer.py,v 2.0 2002/02/08 16:50:31 johanc Exp $'''
__version__='$Revision: 2.0 $'[11:-2]



import Globals
from Globals import DTMLFile, default__class_init__
#from Globals import MessageDialog
#from Globals import Persistent
from Products.ZPatterns.Customizers import CustomizerFolder, manage_addCustomizerFolderForm
from Products.ZPatterns.SkinScript.Methods import SSMethod



DEFAULT_SKINSCRIPT =  """
WITH SELF COMPUTE total_cost = 999
WITH SELF COMPUTE fullname = first + " " + last
"""


def manage_addCustomizerFolder(self, id, title='', REQUEST=None):
    """Add a EmployXCustomizer to a folder."""
    ob = EmployXCustomizer(id, title)
    self._setObject(id,ob)
    ob = ob.__of__(self)


    ob.Customizers_._constructPlugIn('Customizer', id='Customizer')

    ob.Customizer.manage_setTypes(meta_types=['EmployX'])


    ob.Customizer._installPlugIn(
        SSMethod('skinscript', title='Computed Attributes')
    )

    ob.Customizer.skinscript.manage_edit('', DEFAULT_SKINSCRIPT)
    ob.Customizer.DataPlugins.manage_first(ids=['skinscript'])

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)




class EmployXCustomizer(CustomizerFolder):
    """Thing that manages EmployX"""

    meta_type = "EmployXCustomizer"

    #newItemForm = DTMLFile('dtml/newItemForm', globals())
    #index_html  = DTMLFile('dtml/index_html_manager', globals())

    def __init__(self, id, title = ''):
        CustomizerFolder.__init__(self, id, title)


    #Typical Specialized Stuff, this should go in a EmployXManager/Specialized
    #def addNewItem(self,emp_id ,REQUEST=None):
    #    """ttw"""
    #    ob = self.newItem(emp_id)
    #    ob.manage_changeProperties(REQUEST=REQUEST)
    #
    #    if REQUEST is not None:
    #        return self.index_html(self, REQUEST,management_view='View')

    #def deleteInstances(self,ids,REQUEST=None):
    #    """ttw"""
    #    for id in ids:
    #        ni = self.getItem(id)
    #        ni.manage_delete()
    #
    #    if REQUEST is not None:
    #        return self.index_html(self, REQUEST,management_view='View')

Globals.InitializeClass(EmployXCustomizer)


def initialize(context):
    """Initialize the EmployXCustomizer product.
    """

    context.registerClass(
            EmployXCustomizer,
            constructors = (
                manage_addCustomizerFolderForm,
                manage_addCustomizerFolder),
            icon = 'www/item.gif'
        )


