__doc__='''EmployX product module
$Id: EmployXManager.py,v 2.0 2002/02/08 16:50:31 johanc Exp $'''
__version__='$Revision: 2.0 $'[11:-2]



import Globals
from Globals import DTMLFile
#from Globals import MessageDialog
#from Globals import Persistent
from Products.ZPatterns.Specialists import Specialist, manage_addSpecialistForm
from Products.ZPatterns.SkinScript.Methods import SSMethod



def manage_addSpecialist(self, id, title='', rack='', REQUEST=None):
    """Add a EmployXManager to a folder."""
    ob = EmployXManager(id, title)
    self._setObject(id,ob)
    ob = ob.__of__(self)

    if rack:
        ob.RacksGroup._constructPlugIn(rack, id='defaultRack')
        ob.defaultRack.manage_setStorage(
                zclass="Products.EmployX.EmployX/EmployX"
                )
        ob.defaultRack._installPlugIn(
            SSMethod('skinscript', title='Computed Attributes')
        )

        ob.defaultRack.skinscript.manage_edit('', DEFAULT_SKINSCRIPT)
        ob.defaultRack.DataPlugins.manage_first(ids=['skinscript'])

    if REQUEST is not None:
        return self.manage_main(self, REQUEST)


DEFAULT_SKINSCRIPT =  """WITH SELF COMPUTE total_cost = 999
WITH SELF COMPUTE fullname = first + " " + last
"""


class EmployXManager(Specialist):
    """Thing that manages EmployX"""

    meta_type = "EmployXManager"

    addEmployForm = DTMLFile('dtml/SaddEmployForm', globals())
    manage_edit = index_html  = DTMLFile('dtml/Smanage_specialist', globals())

    def __init__(self, id, title = ''):
        Specialist.__init__(self, id, title)

    manage_options_left = (
            {'label': 'Edit',       'action': 'manage_edit' },
        ) + Specialist.manage_options_left
    #EmployXManager.inheritedAttribute('manage_options_left')
    #manage_options_left = {'label':'Methods', 'action':'manage_main'},
    #manage_options_right = tuple(Folder.manage_options[1:])

    def addNewItem(self,emp_id ,first, last, salary, REQUEST=None):
        """ttw"""
        ob = self.newItem(emp_id)
        #ob.manage_changeProperties(REQUEST=REQUEST)
        ob = self.getEmploy(emp_id)
        ob.first=first
        ob.last=last
        ob.salary=salary

        if REQUEST is not None:
            return self.index_html(self, REQUEST,management_view='View')


    def getEmploy(self,emp_id ,REQUEST=None):
        """ttw"""
        ob = self.getItem(emp_id)
        return ob

    def deleteEmploy(self,ids,REQUEST=None):
        """ttw"""
        for id in ids:
            ni = self.getItem(id)
            ni.manage_delete()

        if REQUEST is not None:
            return self.index_html(self, REQUEST,management_view='View')

Globals.InitializeClass(EmployXManager)


def initialize(context):
    """Initialize the EmployXManager product.
    """

    context.registerClass(
            EmployXManager,
            constructors = (
                manage_addSpecialistForm,
                manage_addSpecialist),
            icon = 'www/item.gif'
        )


