====================================================
====================================================
createEmploy 

emp_id:string
first:string
last:string
email:string
salary:int
zopeurl:string

INSERT INTO employ (
    emp_id,
    first,
    last,
    email,
    salary,
    zopeurl 
)
VALUES
(
    <dtml-sqlvar emp_id type="string">,
    <dtml-sqlvar first type="string" optional>,
    <dtml-sqlvar last type="string" optional>,
    <dtml-sqlvar email type="string" optional>,
    <dtml-sqlvar salary type="int">,
    <dtml-sqlvar zopeurl type="string">
)
====================================================
getEmploy 

emp_id:string

select * 
from employ 
where 
<dtml-sqltest emp_id type="string">
====================================================
removeEmploy 

emp_id:string

INSERT INTO employ_undo (
    emp_id,
    first,
    last,
    email,
    sql_value,
    salary,
    zopeurl 
) 
SELECT emp_id, first, last, email, sql_value, salary, zopeurl
FROM employ
WHERE
<dtml-sqltest emp_id type="string">

<dtml-var sql_delimiter>

DELETE FROM
  employ
WHERE 
  <dtml-sqltest emp_id type="string">

====================================================
updateEmploy 

emp_id:string
first:string
last:string
email:string
salary:int
zopeurl:string

UPDATE
  employ
SET
  employ.first = <dtml-sqlvar first type="string">,
  employ.last = <dtml-sqlvar last type="string">,
  employ.email = <dtml-sqlvar email type="string">,
  employ.salary = <dtml-sqlvar salary type="int">,
  employ.zopeurl = <dtml-sqlvar zopeurl type="string">
WHERE <dtml-sqltest emp_id type="string">